Overview

The Zenkraft API is designed to be as standardized across all carriers as possible. The basic structure of each request is the same, with carrier-specific fields typically nested within special services.



OpenAPI 3 Specification

This API is also available in a machine-readable form as a OpenAPI 3 document

  • Basic authentication using a JWT token

  • RESTful using HTTP Verbs

  • JSON requests and responses


Test Tracking Numbers

The tracking numbers can be used below for testing purposes:

  • TEST100000001 - information sent to carrier
  • TEST100000002 - picked up
  • TEST100000003 - in transit
  • TEST100000004 - out for delivery
  • TEST100000005 - delivered
  • TEST100000006 - exception


Authentication

The Zenkraft API uses a bearer token to authenticate. If you do not have one, please contact support.

zkkey : your_api_key
Base URL
https://api.zenkraft.com

/shippingaccount POST

The /shippingaccount endpoint enables you to use your carrier account credentials to create a Shipping Acccount ID in the Zenkraft system. This is used for all future API calls listed below.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
shipping_account object required
auth object Carrier credentials which are specific to each carrier {'account_number': 'XXXXXXXX', 'meter_number': 'XXXXXXXX', 'key': 'XXXXXXXXXXXXXXXXXXXXXXXX', 'password': 'XXXXXXXXXXXXXXXXXXXXXXXX'}
billing_address object
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO MS RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP DZ BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT JE VA CU VC US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
carrier string Carrier slug required fedex
country string required BV PN MX LA FO KY HN PY IN IS VA ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC JE MG AZ TG LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT DZ CU MS VC US
defaults object
currency string BSD USD LBP CVE GEL PGK IMP TVD ISK PKR VEF GYD XAF KHR TND INR SLL NOK LSL SAR BMD TJS MAD AOA TZS ARS ERN AZN BHD VUV BDT JEP PAB BRL PYG LAK SOS BGN CUP AFN ETB GTQ AED ANG ILS IQD MGA SDG RON BYN SEK THB CLP VND JPY GGP MNT CHF TRY GBP EGP RUB EUR MZN SCR HUF XPF JMD TWD RSD DJF STN KRW OMR CNY MVR MMK TOP TTD CZK MXN ZWD BZD GIP SBD QAR LRD AWG TMT UYU RWF SHP ALL MYR BBD CUC CRC BAM MDL KWD SYP BIF KYD KMF AMD WST MUR BOB PEN KPW KGS KZT BND NZD SRD AUD BWP GNF CDF JOD YER HKD MWK NAD FJD UAH UGX FKP HRK MKD MOP SZL LKR CAD SGD ZAR COP GHS DOP BTN XDR NGN HNL ZMW KES NPR XCD HTG IRR IDR PHP UZS DZD LYD SVC NIO GMD SPL MRU XOF PLN DKK
dim_units string Dimension units of the packages, inches or centimeters CM IN IN
label_type string Label Type PDF
packaging_type string Packaging Type your_packaging
service string Service Type domestic_standard
weight_units string Weight units of the packages, pounds or kilograms KG LB LB
location_id string Location ID 0d349ee54a8c4d0dbc61b1a3ac1ab1f4
name string Account name My FedEx test account
parent_shipping_account string Shipping account key to link this account to. This is useful when you want to create a sub-account
test boolean If you specify test flag and omit `auth` key, we'll try to create a shipping account with our test credentials for the carrier/country combination specified


Successful Response
Field Possible Values Example
shipping_account object
auth object Carrier credentials which are specific to each carrier {'account_number': 'XXXXXXXX', 'meter_number': 'XXXXXXXX', 'key': 'XXXXXXXXXXXXXXXXXXXXXXXX', 'password': 'XXXXXXXXXXXXXXXXXXXXXXXX'}
carrier string Carrier slug required fedex
country string required BV PN MX LA FO KY HN PY IN IS VA ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC JE MG AZ TG LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT DZ CU MS VC US
defaults object required
currency string BSD USD LBP CVE GEL PGK IMP TVD ISK PKR VEF GYD XAF KHR TND INR SLL NOK LSL SAR BMD TJS MAD AOA TZS ARS ERN AZN BHD VUV BDT JEP PAB BRL PYG LAK SOS BGN CUP AFN ETB GTQ AED ANG ILS IQD MGA SDG RON BYN SEK THB CLP VND JPY GGP MNT CHF TRY GBP EGP RUB EUR MZN SCR HUF XPF JMD TWD RSD DJF STN KRW OMR CNY MVR MMK TOP TTD CZK MXN ZWD BZD GIP SBD QAR LRD AWG TMT UYU RWF SHP ALL MYR BBD CUC CRC BAM MDL KWD SYP BIF KYD KMF AMD WST MUR BOB PEN KPW KGS KZT BND NZD SRD AUD BWP GNF CDF JOD YER HKD MWK NAD FJD UAH UGX FKP HRK MKD MOP SZL LKR CAD SGD ZAR COP GHS DOP BTN XDR NGN HNL ZMW KES NPR XCD HTG IRR IDR PHP UZS DZD LYD SVC NIO GMD SPL MRU XOF PLN DKK
dim_units string Dimension units of the packages, inches or centimeters CM IN IN
label_type string Label Type PDF
packaging_type string Packaging Type your_packaging
service string Service Type domestic_standard
weight_units string Weight units of the packages, pounds or kilograms KG LB LB
id string Shipping account number required 5190163571408896
location_id string Location ID 0d349ee54a8c4d0dbc61b1a3ac1ab1f4
name string Account name My FedEx test account
parent_shipping_account string Shipping account key to link this account to. This is useful when you want to create a sub-account
test boolean If you specify test flag and omit `auth` key, we'll try to create a shipping account with our test credentials for the carrier/country combination specified


Error Response
Field Possible Values Example
error object
code string Standardized error code required schema_validation_error missing_api_key shipping_account_not_found schema_field_required wrong_api_key master_test_shipping_account_not_found unexpected_exception shipping_account_wrong_carrier master_test_shipping_account_not_found
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required Master shipping account for fedex in US does not exist
Example Request / Response
{
    "shipping_account": {
        "name": "Test",
        "carrier": "fedex",
        "country": "US",
        "test" : true
    }
}
                curl --request POST \
--url https://api.zenkraft.com/shippingaccount \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "shipping_account": {
        "name": "Test",
        "carrier": "fedex",
        "country": "US",
        "test" : true
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "shipping_account": {
        "name": "Test",
        "carrier": "fedex",
        "country": "US",
        "test" : true
    }
}
url = "https://api.zenkraft.com/shippingaccount"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
    "shipping_account": {
        "name": "My FedEx test account",
        "carrier": "fedex",
        "country": "US",
        
        "test": false,
        "id": "567293923024"
    }
}

/rate POST

The rating endpoint is used to return estimated costs & time in transit data from the carrier. Zenkraft normalize this data across carriers providing a standardized date and cost format from the carriers (where the functionality is supported).

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
shipment object Definition of the shipment payload required
currency string BSD USD LBP CVE GEL PGK IMP TVD ISK PKR VEF GYD XAF KHR TND INR SLL NOK LSL SAR BMD TJS MAD AOA TZS ARS ERN AZN BHD VUV BDT JEP PAB BRL PYG LAK SOS BGN CUP AFN ETB GTQ AED ANG ILS IQD MGA SDG RON BYN SEK THB CLP VND JPY GGP MNT CHF TRY GBP EGP RUB EUR MZN SCR HUF XPF JMD TWD RSD DJF STN KRW OMR CNY MVR MMK TOP TTD CZK MXN ZWD BZD GIP SBD QAR LRD AWG TMT UYU RWF SHP ALL MYR BBD CUC CRC BAM DKK KWD SYP BIF KYD KMF AMD WST MUR BOB PEN KPW KGS KZT BND NZD SRD AUD BWP GNF CDF JOD YER HKD MWK NAD FJD UAH UGX FKP HRK MKD MOP SZL LKR CAD SGD ZAR COP GHS DOP BTN XDR NGN HNL ZMW KES NPR XCD HTG IRR IDR PHP UZS DZD LYD SVC NIO GMD SPL MRU XOF PLN MDL
debug boolean calls with debug=true will be logged
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
packaging string the packaging type required your_packaging your_packaging
recipient object required
city string the city of the recipient Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ JE LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT DZ VA MS CU VC US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
sender object required
city string the city of the recipient Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ JE LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT DZ VA MS CU VC US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string if you specify the service type, you'll get rates only for this service fedex_ground
ship_date string shipping date in the ISO format 2021-06-07
shipping_account string Shipping account number required 5190163571408896
special_services array [saturday_delivery ]
test boolean calls created with test = true will be directed to the carrier test servers
type string outbound or return shipments return outbound outbound
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Successful Response
Field Possible Values Example
rates array
currency string USD AED AFN ALL AMD ANG AOA ARS AUD AWG AZN BAM BBD BDT BGN BHD BIF BMD BND BOB BRL BSD BTN BWP BYN BZD CAD CDF CHF CLP CNY COP CRC CUC CUP CVE CZK DJF DKK DOP DZD EGP ERN ETB EUR FJD FKP GBP GEL GGP GHS GIP GMD GNF GTQ GYD HKD HNL HRK HTG HUF IDR ILS IMP INR IQD IRR ISK JEP JMD JOD JPY KES KGS KHR KMF KPW KRW KWD KYD KZT LAK LBP LKR LRD LSL LYD MAD MDL MGA MKD MMK MNT MOP MRU MUR MVR MWK MXN MYR MZN NAD NGN NIO NOK NPR NZD OMR PAB PEN PGK PHP PKR PLN PYG QAR RON RSD RUB RWF SAR SBD SCR SDG SEK SGD SHP SLL SOS SPL SRD STN SVC SYP SZL THB TJS TMT TND TOP TRY TTD TVD TWD TZS UAH UGX UYU UZS VEF VND VUV WST XAF XCD XDR XOF XPF YER ZAR ZMW ZWD
delivery_day string Day of the week of the delivery. This field is optional depending on the carrier Mon
estimated_date string Number of days to ship. This field is optional depending on the carrier 2021-06-04
service_name string carrier supplied name of this service FedEx Freight
service_type string service slug which can be used when selecting a service in /ship fedex_ground
total_cost string total estimated price for this shipment 192.16
transit_days integer Number of days to ship. This field is optional depending on the carrier 3


Error Response
Field Possible Values Example
error object
code string Standardized error code required schema_validation_error ship_date_past missing_api_key shipping_account_not_found schema_field_required wrong_api_key carrier_http_exception carrier_timeout carrier_exception unexpected_exception carrier_throttling carrier_unsupported_method shipping_account_wrong_carrier carrier_failed_connection carrier_authentication carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: The origin country code XX could not be found. Please check the country code.
Example Request / Response
{
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-03-05",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/rate \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-03-05",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-03-05",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}
url = "https://api.zenkraft.com/rate"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "rates": [
    {
      "currency": "USD",
      "service_name": "Express",
      "service_type": "economy",
      "total_cost": "192.16",
      "estimated_date": "2026-03-05",
      "delivery_day": "Mon",
      
      "transit_days": 3
    }
  ]
}

/ship POST

The shipping endpoint is used to book shipments with . It will return a shipping label and tracking number in the response.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
shipment object Definition of the shipment payload required
combined_labels boolean Optional flag indicating whether package labels should be combined
currency string BSD USD LBP CVE GEL PGK IMP TVD ISK PKR VEF GYD XAF KHR TND INR SLL NOK LSL SAR BMD TJS MAD AOA TZS ARS ERN AZN BHD VUV BDT JEP PAB BRL PYG LAK SOS BGN CUP AFN ETB GTQ AED ANG ILS IQD MGA SDG RON BYN SEK THB CLP VND JPY GGP MNT CHF TRY GBP EGP RUB EUR MZN SCR HUF XPF JMD TWD RSD DJF STN KRW OMR CNY MVR MMK TOP TTD CZK MXN ZWD BZD GIP SBD QAR LRD AWG TMT UYU RWF SHP ALL MYR BBD CUC CRC BAM MDL KWD SYP BIF KYD KMF AMD WST MUR BOB PEN KPW KGS KZT BND NZD SRD AUD BWP GNF CDF JOD YER HKD MWK NAD FJD UAH UGX FKP HRK MKD MOP SZL LKR CAD SGD ZAR COP GHS DOP BTN XDR NGN HNL ZMW KES NPR XCD HTG IRR IDR PHP UZS DZD LYD SVC NIO GMD SPL MRU XOF PLN DKK
debug boolean calls with debug=true will be logged
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
documents array
document string document content
document_type string file format of the document pdf
id string uploaded document ID
include_base64_label boolean If this is enabled, base64 label is returned
label_size string the shipping labels size 4x6
label_type string the label format of the shipping labels required PDF JPG GIF ZPL PNG PDF
notifications array
type string type of the notification needed sms email email
value string value of the notification notification1@example.com
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
packaging string the packaging type required your_packaging your_packaging
recipient object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ JE LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT DZ VA MS CU VC US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
references array
type string type of reference customer_reference
value string value of the reference ABC-000123
sender object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ JE LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT DZ VA MS CU VC US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string the service type required fedex_ground
ship_date string shipping date in the ISO format 2021-06-07
shipping_account string Shipping account number required 5190163571408896
special_services array [saturday_delivery ]
test boolean calls created with test = true will be directed to the carrier test servers
type string outbound or return shipments return outbound outbound
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Successful Response
Most important parts of the response:
  • tracking_number which can be used to track the shipments in the track endpoint
  • label for each package which needs to be printed and attached to the shipment
Field Possible Values Example
shipment object
context object this object can contain custom data returned by the carrier
costs object Additional information about packages
base_charge number gross amount 100
discounts number the cost of discounts applied 0
net_charge number net amount 80
surcharges number additional fees 0
taxes number the cost of taxes 20
id string shipment ID 1f02d12868a54ed88b6cb4dafaad325d
packages array
height number height of the package according to units specified under dim_units 5
label string base64 label if you specify include_base64_label flag in your request or an URL to the generated label
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
tracking_number string Tracking number of shipment 567293923024
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
shipping_documents object Additional information about packages
description string description of this customs item required Commercial Invoice
document string base64 document contents required
document_type string file format of the document required PDF
tracking_number string Tracking number of shipment 567293923024


Error Response
Field Possible Values Example
error object
code string Standardized error code required schema_validation_error ship_date_past invalid_phone_number missing_api_key shipping_account_not_found schema_field_required wrong_api_key carrier_http_exception carrier_timeout carrier_label_generation_failed carrier_shipment_generation_failed carrier_exception unexpected_exception carrier_throttling carrier_unsupported_method shipping_account_wrong_carrier carrier_failed_connection carrier_authentication carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: The origin country code XX could not be found. Please check the country code.
Example Request / Response
{
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-03-05",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/ship \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-03-05",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-03-05",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}
url = "https://api.zenkraft.com/ship"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "shipment": {
    "carrier": "fedex",
    "shipping_account": "5190163571408896",
    "test": true,
    "debug": false,
    "ship_date": "2026-03-05",
    "type": "outbound",
    "combined_labels": false,
    "service": "economy",
    "special_services": [
      "saturday_delivery"
    ],
    "packaging": "your_packaging",
    "dim_units": "IN",
    "weight_units": "LB",
    "currency": "USD",
    "sender": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US"
    },
    "recipient": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US"
    },
    "packages": [
      {
        "weight": 4.2,
        "value": 25,
        "length": 11,
        "width": 8.5,
        "height": 5,
        "tracking_number": "567293923024",
        "label": "string"
      }
    ],
    "label_type": "PDF",
    "include_base64_label": false,
    "references": [
      {
        "type": "customer_reference",
        "value": "ABC-000123"
      }
    ],
    "notifications": [
      {
        "type": "email",
        "value": "notification1@example.com"
      }
    ],
    "costs": {
      "base_charge": 100,
      "net_charge": 80,
      "taxes": 20,
      "surcharges": 0,
      "discounts": 0
    },
    "id": "1f02d12868a54ed88b6cb4dafaad325d",
    "tracking_number": "567293923024",
    "shipping_documents": [{
      "description": "Commercial Invoice",
      "document_type": "PDF",
      "document": "string"
    }],
    "context": {}
  }
}

/ship GET

This endpoint allows you to retrieve previously created shipments

GET Request Parameters
Field Possible Values Example
shipment_id object ID of the previously created shipment returned from POST on /ship required


Successful Response
Field Possible Values Example
shipment object
carrier string the carrier name fedex
created string when was this object created 2021-06-02T07:22:43.000
id string shipment ID 1f02d12868a54ed88b6cb4dafaad325d
label string base64 label
label_type string the label format of the shipping labels PDF JPG GIF ZPL PNG PDF
shipping_account string Shipping account number 5190163571408896
status string Standardized shipment status success pending success
tracking_number string Tracking number of shipment 567293923024
updated string when was this object updated 2021-06-02T13:10:02.000


Error Response
Field Possible Values Example
error object
code string Standardized error code required schema_validation_error missing_api_key shipping_account_not_found schema_field_required wrong_api_key carrier_http_exception carrier_timeout carrier_label_generation_failed carrier_no_shipment_found carrier_exception unexpected_exception carrier_throttling carrier_unsupported_method shipping_account_wrong_carrier carrier_failed_connection carrier_authentication carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required DHL Global Forwarding API: Your shipment was rejected due to an unpaid invoice on your previous shipment. Contact DHL support to resolve the issue.
Example Request / Response
https://api.zenkraft.com/ship/b87ff34556ec4dba9e724963216d2dd7
                curl --request GET \
--url https://api.zenkraft.com/ship/b87ff34556ec4dba9e724963216d2dd7 \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = None
url = "https://api.zenkraft.com/ship/b87ff34556ec4dba9e724963216d2dd7"

response = requests.request(url=url, method='GET', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "shipment": {
    "carrier": "fedex",
    "shipping_account": "5190163571408896",
    "test": true,
    "debug": false,
    "ship_date": "2026-03-05",
    "type": "outbound",
    "combined_labels": false,
    "service": "economy",
    "special_services": [
      "saturday_delivery"
    ],
    "packaging": "your_packaging",
    "dim_units": "IN",
    "weight_units": "LB",
    "currency": "USD",
    "sender": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US"
    },
    "recipient": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US"
    },
    "packages": [
      {
        "weight": 4.2,
        "value": 25,
        "length": 11,
        "width": 8.5,
        "height": 5,
        "tracking_number": "567293923024",
        "label": "string"
      }
    ],
    "label_type": "PDF",
    "include_base64_label": false,
    "references": [
      {
        "type": "customer_reference",
        "value": "ABC-000123"
      }
    ],
    "notifications": [
      {
        "type": "email",
        "value": "notification1@example.com"
      }
    ],
    "costs": {
      "base_charge": 100,
      "net_charge": 80,
      "taxes": 20,
      "surcharges": 0,
      "discounts": 0
    },
    "id": "1f02d12868a54ed88b6cb4dafaad325d",
    "tracking_number": "567293923024",
    "shipping_documents": [{
      "description": "Commercial Invoice",
      "document_type": "PDF",
      "document": "string"
    }],
    "context": {}
  }
}

/track POST

The track endpoint is used to track shipment status as it's being delivered.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
track object required
checkpoints boolean whether to include checkpoint events in the response or not
debug boolean calls with debug=true will be logged
locale string language used in the checkpoint response. Not all carriers support different languages fr_BJ fr_CG mas_KE sw_TZ shi_Tfng_MA ar_BH fr_GQ ar_OM ee_GH rof_TZ az_Latn sr_Latn ar_YE luo_KE so_DJ pt_GW ar_EG fr_BF nl_NL en_HK en_MT hu_HU pl_PL te_IN en_BZ es_GT ii_CN ti_ER ti_ET fr_MG tzm_Latn bn_BD zh_Hans_SG sr_Cyrl es_PY yo_NG nyn_UG ro_MD de_LI sr_Cyrl_RS az_Latn_AZ saq_KE bo_IN km_KH rw_RW ps_AF so_KE mk_MK sr_Latn_BA ar_TN en_MH pa_Guru_IN fr_CD my_MM uk_UA fr_FR hr_HR fr_RE guz_KE ne_NP sw_KE shi_Latn_MA kw_GB cgg_UG de_BE en_NA pa_Arab ru_RU ig_NG fr_CI ur_PK ar_LB es_CL cy_GB az_Cyrl_AZ fr_DJ gu_IN ar_KW tr_TR eu_ES mg_MG en_BE luy_KE is_IS mfe_MU sv_SE teo_KE fr_GP sr_Latn_ME de_CH ar_IQ fr_MC bn_IN de_LU bm_ML pt_BR ar_SY kam_KE uz_Cyrl bs_BA ar_JO fr_TD ha_Latn_GH be_BY en_PH rm_CH sn_ZW uz_Arab_AF it_IT es_MX fr_SN et_EE kn_IN en_TT en_VI nb_NO ar_QA ki_KE om_KE ro_RO om_ET gv_GB shi_Latn fr_CM so_SO fr_ML uz_Arab or_IN es_EC asa_TZ kea_CV ca_ES hy_AM nl_BE es_PA rwk_TZ es_419 ta_IN en_ZW es_CO bo_CN teo_UG en_IE en_IN ru_MD fr_GA kok_IN ar_LY fo_FO ga_IE en_MP es_VE bg_BG es_UY fr_BI sr_Cyrl_ME es_HN dav_KE ar_MA chr_US ja_JP th_TH fr_GN hi_IN ka_GE af_ZA ur_IN kk_Cyrl mr_IN fr_MQ ko_KR en_CA es_PR es_US vi_VN it_CH mas_TZ fil_PH zh_Hans_CN mer_KE pa_Guru shi_Tfng ak_GH en_ZA en_GB fr_MF fr_BL pa_Arab_PK ar_SA ar_SD sl_SI haw_US xog_UG en_JM es_SV fr_CA fr_CF en_IL fr_KM en_SG da_DK lv_LV naq_NA fi_FI az_Cyrl fa_IR so_ET es_GQ sv_FI af_NA sr_Latn_RS fr_TG ee_TG zh_Hans fr_RW ar_DZ en_UM kab_DZ kde_TZ es_AR en_AS zu_ZA fr_NE as_IN gl_ES khq_ML sg_CF ar_AE ha_Latn_NE lt_LT en_PK pt_MZ zh_Hant_MO sr_Cyrl_BA es_PE es_ES es_BO gsw_CH zh_Hant_TW ta_LK en_MU ms_MY zh_Hant en_NZ es_NI ha_Latn_NG to_TO jmc_TZ sq_AL lg_UG si_LK zh_Hans_HK el_GR yue_Hant_HK en_AU ms_BN el_CY zh_Hans_MO uz_Latn_UZ mt_MT ru_UA ebu_KE nd_ZW id_ID fa_AF bem_ZM de_AT uz_Cyrl_UZ pt_PT ne_IN es_CR zh_Hant_HK nn_NO es_DO kl_GL fr_BE kln_KE cs_CZ ff_SN vun_TZ seh_MZ uz_Latn bez_TZ lag_TZ ml_IN kk_Cyrl_KZ en_US fr_LU ha_Latn de_DE ses_ML en_GU sk_SK tzm_Latn_MA en_BW fr_CH am_ET he_IL en_US
refresh boolean whether to force calling live carrier API. By default, we might return a fresh result from the cache
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
tracking_number string Tracking number of shipment required 567293923024
webhooks boolean whether to allow webhook functionality for this shipment


Successful Response
Field Possible Values Example
carrier string the carrier name fedex
checkpoints array
description string Delivered to a mailbox
status string the most recent important status description Delivered to a mailbox
time string 2021-06-07T10:46:07.000+1000
tracking_stage string the most recent important status standardized shipment stage CREATION_PENDING CREATED PICKED_UP IN_TRANSIT OUT_FOR_DELIVERY DRIVER_ASSIGNED CHECKED_IN DELIVERED SHIPMENT_VOIDED EXCEPTION DELIVERED
delivered boolean whether the shipment was successfully delivered
delivery_date string delivery date of this shipment 2021-06-07T00:00:00.000Z
estimated_delivery string estimated delivery date of this shipment 2021-06-07T00:00:00.000Z
locale string locale used in the checkpoint response. Not all carriers support different languages fr_BJ fr_CG mas_KE sw_TZ shi_Tfng_MA ar_BH fr_GQ ar_OM ee_GH rof_TZ az_Latn sr_Latn ar_YE luo_KE so_DJ pt_GW ar_EG fr_BF nl_NL en_HK en_MT hu_HU pl_PL te_IN en_BZ es_GT ii_CN ti_ER ti_ET fr_MG tzm_Latn bn_BD zh_Hans_SG sr_Cyrl es_PY yo_NG nyn_UG ro_MD de_LI sr_Cyrl_RS az_Latn_AZ saq_KE bo_IN km_KH rw_RW ps_AF so_KE mk_MK sr_Latn_BA ar_TN en_MH pa_Guru_IN fr_CD my_MM uk_UA fr_FR hr_HR fr_RE guz_KE ne_NP sw_KE shi_Latn_MA kw_GB cgg_UG de_BE en_NA ig_NG pa_Arab ru_RU fr_CI ur_PK ar_LB es_CL cy_GB az_Cyrl_AZ fr_DJ gu_IN ar_KW tr_TR eu_ES mg_MG en_BE luy_KE is_IS mfe_MU sv_SE teo_KE fr_GP sr_Latn_ME de_CH ar_IQ fr_MC bn_IN de_LU bm_ML pt_BR ar_SY kam_KE uz_Cyrl bs_BA ar_JO fr_TD ha_Latn_GH be_BY en_PH rm_CH sn_ZW uz_Arab_AF it_IT es_MX fr_SN et_EE kn_IN en_TT en_VI nb_NO ar_QA ki_KE om_KE ro_RO om_ET gv_GB shi_Latn fr_CM so_SO fr_ML uz_Arab or_IN es_EC asa_TZ kea_CV ca_ES hy_AM nl_BE es_PA rwk_TZ es_419 ta_IN en_ZW es_CO bo_CN teo_UG en_IE en_IN ru_MD fr_GA kok_IN ar_LY fo_FO ga_IE en_MP es_VE bg_BG es_UY fr_BI sr_Cyrl_ME es_HN dav_KE ar_MA chr_US ja_JP th_TH fr_GN hi_IN ka_GE af_ZA ur_IN kk_Cyrl mr_IN fr_MQ ko_KR en_CA es_PR es_US vi_VN it_CH mas_TZ fil_PH zh_Hans_CN mer_KE pa_Guru shi_Tfng ak_GH en_ZA en_GB fr_MF fr_BL pa_Arab_PK ar_SA ar_SD sl_SI haw_US xog_UG en_JM es_SV fr_CA fr_CF en_IL fr_KM en_SG da_DK lv_LV naq_NA fi_FI az_Cyrl fa_IR so_ET es_GQ sv_FI af_NA sr_Latn_RS fr_TG ee_TG zh_Hans fr_RW ar_DZ en_UM kab_DZ kde_TZ es_AR en_AS zu_ZA fr_NE as_IN gl_ES khq_ML sg_CF ar_AE ha_Latn_NE lt_LT en_PK pt_MZ zh_Hant_MO sr_Cyrl_BA es_PE es_ES es_BO gsw_CH zh_Hant_TW ta_LK en_MU ms_MY zh_Hant en_NZ es_NI ha_Latn_NG to_TO jmc_TZ sq_AL lg_UG si_LK zh_Hans_HK el_GR yue_Hant_HK en_AU ms_BN el_CY zh_Hans_MO uz_Latn_UZ mt_MT ru_UA ebu_KE nd_ZW id_ID fa_AF bem_ZM de_AT uz_Cyrl_UZ pt_PT ne_IN es_CR zh_Hant_HK nn_NO es_DO kl_GL fr_BE kln_KE cs_CZ ff_SN vun_TZ seh_MZ uz_Latn bez_TZ lag_TZ ml_IN kk_Cyrl_KZ en_US fr_LU ha_Latn de_DE ses_ML en_GU sk_SK tzm_Latn_MA en_BW fr_CH am_ET he_IL en_US
status string the most recent important status description Delivered to a mailbox
tracking_number string Tracking number of shipment 567293923024
tracking_stage string the most recent important status standardized shipment stage CREATION_PENDING CREATED PICKED_UP IN_TRANSIT OUT_FOR_DELIVERY DRIVER_ASSIGNED CHECKED_IN DELIVERED SHIPMENT_VOIDED EXCEPTION DELIVERED


Error Response
Field Possible Values Example
error object
code string Standardized error code required schema_validation_error missing_api_key shipping_account_not_found schema_field_required wrong_api_key carrier_http_exception carrier_timeout carrier_no_shipment_found carrier_exception unexpected_exception carrier_throttling carrier_unsupported_method shipping_account_wrong_carrier carrier_failed_connection carrier_authentication carrier_no_shipment_found
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: No shipment found with tracking number: 567293923024
Example Request / Response
{
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/track \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
}
url = "https://api.zenkraft.com/track"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "carrier": "fedex",
  "delivered": true,
  "estimated_delivery": "2021-06-07T00:00:00.000Z",
  "delivery_date": "2021-06-07T00:00:00.000Z",
  "tracking_number": "567293923024",
  "status": "Delivered to a mailbox",
  "tracking_stage": "DELIVERED",
  "checkpoints": [
    {
      "description": "Delivered to a mailbox",
      "status": "Delivered to a mailbox",
      "tracking_stage": "DELIVERED",
      "time": "2021-06-07T10:46:07.000+1000"
    }
  ]
}

Batch tracking

You can pass several track objects into your API request to get results.
Request and response details are the same and can be checked here.

Example Request / Response
[
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  },
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  }
]
                curl --request POST \
--url https://api.zenkraft.com/track \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '[
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  },
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  }
]'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = [
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  },
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  }
]
url = "https://api.zenkraft.com/track"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
[
  {
    "carrier": "fedex",
    "delivered": true,
    "estimated_delivery": "2021-06-07T00:00:00.000Z",
    "delivery_date": "2021-06-07T00:00:00.000Z",
    "tracking_number": "567293923024",
    "status": "Delivered to a mailbox",
    "tracking_stage": "DELIVERED",
    "checkpoints": [
      {
        "description": "Delivered to a mailbox",
        "status": "Delivered to a mailbox",
        "tracking_stage": "DELIVERED",
        "time": "2021-06-07T10:46:07.000+1000"
      }
    ]
  },
  {
    "carrier": "fedex",
    "delivered": true,
    "estimated_delivery": "2021-06-07T00:00:00.000Z",
    "delivery_date": "2021-06-07T00:00:00.000Z",
    "tracking_number": "567293923024",
    "status": "Delivered to a mailbox",
    "tracking_stage": "DELIVERED",
    "checkpoints": [
      {
        "description": "Delivered to a mailbox",
        "status": "Delivered to a mailbox",
        "tracking_stage": "DELIVERED",
        "time": "2021-06-07T10:46:07.000+1000"
      }
    ]
  }
]

/cancel POST

The cancel endpoint allows you to cancel shipments with the carrier.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
cancel object required
checkpoints boolean whether to include checkpoint events in the response or not
debug boolean calls with debug=true will be logged
locale string language used in the checkpoint response. Not all carriers support different languages fr_BJ fr_CG mas_KE sw_TZ shi_Tfng_MA ar_BH fr_GQ ar_OM ee_GH rof_TZ az_Latn sr_Latn ar_YE luo_KE so_DJ pt_GW ar_EG fr_BF nl_NL en_HK en_MT hu_HU pl_PL te_IN en_BZ es_GT ii_CN ti_ER ti_ET fr_MG tzm_Latn bn_BD zh_Hans_SG sr_Cyrl es_PY yo_NG nyn_UG ro_MD de_LI sr_Cyrl_RS az_Latn_AZ saq_KE bo_IN km_KH rw_RW ps_AF so_KE mk_MK sr_Latn_BA ar_TN en_MH pa_Guru_IN fr_CD my_MM uk_UA fr_FR hr_HR fr_RE guz_KE ne_NP sw_KE shi_Latn_MA kw_GB cgg_UG de_BE en_NA pa_Arab ru_RU fr_CI ur_PK ar_LB es_CL cy_GB az_Cyrl_AZ fr_DJ gu_IN ar_KW tr_TR eu_ES mg_MG en_BE luy_KE is_IS mfe_MU sv_SE teo_KE fr_GP sr_Latn_ME de_CH ar_IQ fr_MC bn_IN de_LU bm_ML pt_BR ar_SY kam_KE uz_Cyrl bs_BA ar_JO fr_TD ha_Latn_GH be_BY en_PH rm_CH sn_ZW uz_Arab_AF it_IT es_MX fr_SN et_EE kn_IN en_TT en_VI nb_NO ar_QA ki_KE om_KE ro_RO om_ET gv_GB shi_Latn fr_CM so_SO fr_ML uz_Arab or_IN es_EC asa_TZ kea_CV ca_ES hy_AM nl_BE es_PA rwk_TZ es_419 ta_IN en_ZW es_CO bo_CN teo_UG en_IE he_IL en_IN ru_MD fr_GA kok_IN ar_LY fo_FO ga_IE en_MP es_VE bg_BG es_UY fr_BI sr_Cyrl_ME es_HN dav_KE ar_MA chr_US ja_JP th_TH fr_GN hi_IN ka_GE af_ZA ur_IN kk_Cyrl mr_IN fr_MQ ko_KR en_CA es_PR es_US vi_VN it_CH mas_TZ fil_PH zh_Hans_CN mer_KE pa_Guru shi_Tfng ak_GH en_ZA en_GB fr_MF fr_BL pa_Arab_PK ar_SA ar_SD sl_SI haw_US xog_UG en_JM es_SV fr_CA fr_CF en_IL fr_KM en_SG da_DK lv_LV naq_NA fi_FI az_Cyrl fa_IR so_ET es_GQ sv_FI af_NA sr_Latn_RS fr_TG ee_TG zh_Hans fr_RW ar_DZ en_UM kab_DZ kde_TZ es_AR en_AS zu_ZA fr_NE as_IN gl_ES khq_ML sg_CF ar_AE ha_Latn_NE lt_LT en_PK pt_MZ zh_Hant_MO sr_Cyrl_BA es_PE es_ES es_BO gsw_CH zh_Hant_TW ta_LK en_MU ms_MY zh_Hant en_NZ es_NI ha_Latn_NG to_TO jmc_TZ sq_AL lg_UG si_LK zh_Hans_HK el_GR yue_Hant_HK en_AU ms_BN el_CY zh_Hans_MO uz_Latn_UZ mt_MT ru_UA ebu_KE nd_ZW id_ID fa_AF bem_ZM de_AT uz_Cyrl_UZ pt_PT ne_IN es_CR zh_Hant_HK nn_NO es_DO kl_GL fr_BE kln_KE cs_CZ ff_SN vun_TZ seh_MZ uz_Latn bez_TZ lag_TZ ml_IN kk_Cyrl_KZ en_US fr_LU ha_Latn de_DE ses_ML en_GU sk_SK tzm_Latn_MA en_BW fr_CH am_ET ig_NG en_US
refresh boolean whether to force calling live carrier API. By default, we might return a fresh result from the cache
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
tracking_number string Tracking number of shipment required 567293923024
webhooks boolean whether to allow webhook functionality for this shipment


Successful Response
Field Possible Values Example
success object
message string Message describing the action was performed successfully Success!


Error Response
Field Possible Values Example
error object
code string Standardized error code required schema_validation_error missing_api_key shipping_account_not_found schema_field_required wrong_api_key carrier_http_exception carrier_timeout carrier_no_shipment_found carrier_exception unexpected_exception carrier_throttling carrier_unsupported_method shipping_account_wrong_carrier carrier_failed_connection carrier_authentication carrier_no_shipment_found
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: No shipment found with tracking number: 567293923024
Example Request / Response
{
    "cancel": {
        "shipping_account": "00000000000000",
        "carrier": "ups",
        "tracking_number": "1Z168R020399800319"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/cancel \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "cancel": {
        "shipping_account": "00000000000000",
        "carrier": "ups",
        "tracking_number": "1Z168R020399800319"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "cancel": {
        "shipping_account": "00000000000000",
        "carrier": "ups",
        "tracking_number": "1Z168R020399800319"
    }
}
url = "https://api.zenkraft.com/cancel"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "success": {
    "message": "The shipment has been canceled successfully"
  }
}

/pickup/availability POST

Find the time slots between the start_date and the end_date during which the carrier can pick up the specified shipments.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
pickup_availability object required
close_time string Reserved for future use 2021-06-04
currency string BSD USD LBP CVE GEL PGK IMP TVD ISK PKR VEF GYD XAF KHR TND INR SLL NOK LSL SAR BMD TJS MAD AOA TZS ARS ERN AZN BHD VUV BDT PAB JEP BRL PYG LAK SOS BGN CUP AFN ETB GTQ AED ANG ILS IQD MGA SDG RON BYN SEK THB CLP VND JPY GGP MNT CHF TRY GBP EGP RUB EUR MZN SCR HUF XPF JMD TWD RSD DJF STN KRW OMR CNY MVR MMK TOP CZK MXN ZWD BZD GIP SBD QAR LRD AWG TMT UYU RWF SHP ALL MYR BBD CUC CRC BAM MDL DKK KWD SYP BIF KYD KMF AMD WST MUR BOB PEN KPW KGS KZT BND NZD SRD AUD BWP GNF CDF JOD YER HKD MWK NAD FJD UAH UGX FKP HRK MKD MOP SZL LKR CAD SGD ZAR COP GHS DOP BTN XDR NGN HNL ZMW KES NPR XCD HTG IRR IDR PHP UZS DZD LYD SVC NIO GMD SPL MRU XOF PLN TTD
debug boolean calls with debug=true will be logged
description string
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
end_date string End of the range of dates to check required 2021-06-04
location object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP DZ BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT JE VA MS CU VC US
email string the email address of the recipient jrogers@example.com
location_type string description of the pickup location required front
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient required (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
ready_time string Reserved for future use 2021-06-04
shipments array required
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
recipient object
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ JE LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT DZ VA MS CU VC US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string the service type fedex_ground
shipping_account string Shipping account number required 5190163571408896
start_date string Start of the range of dates to check required 2021-06-04
test boolean calls created with test = true will be directed to the carrier test servers
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Successful Response
Field Possible Values Example
pickup_availability object
dates array
date string Pickup date 2021-06-04
earliest string The earliest time the shipments can be picked up 09:00
latest string The latest time the shipments can be picked up 18:00
debug boolean calls with debug=true will be logged
dim_units string Dimension units of the packages, inches or centimeters CM IN IN
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
weight_units string Weight units of the packages, pounds or kilograms KG LB LB


Error Response
Field Possible Values Example
error object
code string Standardized error code required schema_validation_error ship_date_past missing_api_key shipping_account_not_found schema_field_required wrong_api_key carrier_http_exception carrier_timeout carrier_exception unexpected_exception carrier_throttling carrier_unsupported_method shipping_account_wrong_carrier carrier_failed_connection carrier_authentication invalid_phone_number carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: The origin country code XX could not be found. Please check the country code.
Example Request / Response
{
    "pickup_availability": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "service": "economy"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "weight_units": "LB",
        "start_date": "2026-03-05",
        "end_date": "2026-03-05"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/pickup/availability \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "pickup_availability": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "service": "economy"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "weight_units": "LB",
        "start_date": "2026-03-05",
        "end_date": "2026-03-05"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "pickup_availability": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "service": "economy"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "weight_units": "LB",
        "start_date": "2026-03-05",
        "end_date": "2026-03-05"
    }
}
url = "https://api.zenkraft.com/pickup/availability"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
    "pickup_availability": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "service": "economy"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "weight_units": "LB",
        "start_date": "2026-03-05",
        "end_date": "2026-03-05",
        "dates": [
            {
                "date" : "2021-06-30",
                "earliest": "09:00",
                "latest": "18:00"
            },
            {
                "date" : "2021-07-01",
                "earliest": "09:00",
                "latest": "18:00"
            },
            {
                "date" : "2021-07-02",
                "earliest": "09:00",
                "latest": "15:00"
            }
        ]
    }
}

/pickup POST

The pickup endpoint allows you to schedule pickups for one or more shipments.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
pickup object required
currency string BSD USD LBP CVE GEL PGK IMP TVD ISK PKR VEF GYD XAF KHR TND INR SLL NOK LSL SAR BMD TJS MAD AOA TZS ARS ERN AZN BHD VUV BDT JEP PAB BRL PYG LAK SOS BGN CUP AFN ETB GTQ AED ANG ILS IQD MGA SDG RON BYN SEK THB CLP VND JPY GGP MNT CHF TRY GBP EGP RUB EUR MZN SCR HUF XPF JMD TWD RSD DJF STN KRW OMR CNY MVR MMK TOP TTD CZK MXN ZWD BZD GIP SBD QAR LRD AWG TMT UYU RWF SHP ALL MYR BBD CUC CRC BAM DKK KWD SYP BIF KYD KMF AMD WST MUR BOB PEN KPW KGS KZT BND NZD SRD AUD BWP GNF CDF JOD YER HKD MWK NAD FJD UAH UGX FKP HRK MKD MOP SZL LKR CAD SGD ZAR COP GHS DOP BTN XDR NGN HNL ZMW KES NPR XCD HTG IRR IDR PHP UZS DZD LYD SVC NIO GMD SPL MRU XOF PLN MDL
debug boolean calls with debug=true will be logged
description string
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
location object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ JE LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT DZ VA MS CU VC US
email string the email address of the recipient jrogers@example.com
location_type string description of the pickup location required front
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient required (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
shipments array required
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
recipient object
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP DZ BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT JE VA MS CU VC US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string the service type fedex_ground
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
time object the date and time you want to create the pickup for. required
close_time string end of pickup time required 19:00
date string the date you want to create pickup for. required 2021-06-07
ready_time string start of pickup time required 12:30
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Successful Response
Field Possible Values Example
pickup object
confirmation_number string reference number of this pickup. It can be used to cancel the pickup if the carrier allows it 123456789
currency string BSD USD LBP CVE GEL PGK IMP TVD ISK PKR VEF GYD XAF KHR TND INR SLL NOK LSL SAR BMD TJS MAD AOA TZS ARS ERN AZN BHD VUV BDT PAB JEP BRL PYG LAK SOS BGN CUP AFN ETB GTQ AED ANG ILS IQD MGA SDG RON BYN SEK THB CLP VND JPY GGP MNT CHF TRY GBP EGP RUB EUR MZN SCR HUF XPF JMD TWD RSD DJF STN KRW OMR CNY MVR MMK TOP CZK MXN ZWD BZD GIP SBD QAR LRD AWG TMT UYU RWF SHP ALL MYR BBD CUC CRC BAM DKK MDL KWD SYP BIF KYD KMF AMD WST MUR BOB PEN KPW KGS KZT BND NZD SRD AUD BWP GNF CDF JOD YER HKD MWK NAD FJD UAH UGX FKP HRK MKD MOP SZL LKR CAD SGD ZAR COP GHS DOP BTN XDR NGN HNL ZMW KES NPR XCD HTG IRR IDR PHP UZS DZD LYD SVC NIO GMD SPL MRU XOF PLN TTD
debug boolean calls with debug=true will be logged
description string
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
id string internal pickup ID cf8a402288034fd9941dc1efe22b0680
location object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP DZ BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT JE VA MS CU VC US
email string the email address of the recipient jrogers@example.com
location_type string description of the pickup location required front
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient required (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
shipments array required
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
recipient object
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ JE LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT DZ VA MS CU VC US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string the service type fedex_ground
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
time object the date and time you want to create the pickup for. required
close_time string end of pickup time required 19:00
date string the date you want to create pickup for. required 2021-06-07
ready_time string start of pickup time required 12:30
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Error Response
Field Possible Values Example
error object
code string Standardized error code required schema_validation_error ship_date_past invalid_phone_number missing_api_key shipping_account_not_found schema_field_required wrong_api_key carrier_http_exception carrier_timeout carrier_exception unexpected_exception carrier_throttling carrier_unsupported_method shipping_account_wrong_carrier carrier_failed_connection carrier_authentication carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: The origin country code XX could not be found. Please check the country code.
Example Request / Response
{
    "pickup": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "recipient": {
                    "country": "US"
                },
                "service": "express_worldwide_p"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "time": {
            "ready_time": "09:45",
            "close_time": "16:45",
            "date": "2021-05-20"
        },
        "weight_units": "LB"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/pickup \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "pickup": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "recipient": {
                    "country": "US"
                },
                "service": "express_worldwide_p"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "time": {
            "ready_time": "09:45",
            "close_time": "16:45",
            "date": "2021-05-20"
        },
        "weight_units": "LB"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "pickup": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "recipient": {
                    "country": "US"
                },
                "service": "express_worldwide_p"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "time": {
            "ready_time": "09:45",
            "close_time": "16:45",
            "date": "2021-05-20"
        },
        "weight_units": "LB"
    }
}
url = "https://api.zenkraft.com/pickup"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "pickup": {
    "confirmation_number": "123456789",
    "id": "cf8a402288034fd9941dc1efe22b0680",
    "carrier": "fedex",
    "shipping_account": "5190163571408896",
    "test": true,
    "debug": false,
    "description": "string",
    "currency": "USD",
    "dim_units": "IN",
    "weight_units": "LB",
    "location": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US",
      "location_type": "front"
    },
    "shipments": [
      {
        "recipient": {
          "name": "Jack O'Rogers",
          "company": "Burlington Textiles Corp of America",
          "street1": "525 S. ZENKRAFT Ave",
          "street2": "suite 120",
          "email": "jrogers@example.com",
          "phone": "(336) 222-7000",
          "city": "Burlington",
          "state": "NC",
          "postal_code": "27215",
          "country": "US"
        },
        "packages": [
          {
            "weight": 4.2,
            "value": 25,
            "length": 11,
            "width": 8.5,
            "height": 5
          }
        ],
        "service": "fedex_ground"
      }
    ],
    "time": {
      "close_time": "19:00",
      "ready_time": "12:30",
      "date": "2021-06-07"
    }
  }
}

/dopu POST

The dopu endpoint is used to retrieve the list of possible drop off locations nearby.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
dopu object required
debug boolean calls with debug=true will be logged
location object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required BV PN MX LA FO KY HN PY IN IS ID BS ES GA NE TT GE SB TL MT AR CL JP BJ EC FR NA HU NR RO UM ZW SO BQ CA GG KN GW RU NO MS RS AL BL BE VI CF BY LU MO MU ZM WF NU EH CN MY ER SD TH TK TW BW UY MV FI LC AU GP ET FM PF UG AS GN BN BA NC TG MG AZ LT MD MF JM EE BI LK MN BH PM ZA UA SH HM ME MQ MR LI QA LB MP RW KM KE KG AI FJ TZ LV SC CD MM GR IQ LR HK GB CH CK JO PK AE DO EG GT SM SY CO AD AF CR TM TO BF CM CC PG SJ BB SL MZ OM TF SS PT HR BG PR PA GD SK YT BM US TD IE KW GF AO GU ST AQ DM GH NG PH PW NI GS ML GY MH KP DZ BZ HT PS SR SZ SG NF AX CI GQ IR NP DK TC VE PL CX TJ CW CZ YE BO TN AG VU AM NZ SX AW SN UZ BR IO GI CV SA WS KZ CY AT DJ VG VN DE IT LS TR LY IM MK PE BD GM KI MW SE IL GL NL RE TV KH FK MA SI KR SV MC CG BT JE VA CU VC US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers


Successful Response
Field Possible Values Example
locations array
city string Burlington
country string AD AE AF AG AI AL AM AO AQ AR AS AT AU AW AX AZ BA BB BD BE BF BG BH BI BJ BL BM BN BO BQ BR BS BT BV BW BY BZ CA CC CD CF CG CH CI CK CL CM CN CO CR CU CV CW CX CY CZ DE DJ DK DM DO DZ EC EE EG EH ER ES ET FI FJ FK FM FO FR GA GB GD GE GF GG GH GI GL GM GN GP GQ GR GS GT GU GW GY HK HM HN HR HT HU ID IE IL IM IN IO IQ IR IS IT JE JM JO JP KE KG KH KI KM KN KP KR KW KY KZ LA LB LC LI LK LR LS LT LU LV LY MA MC MD ME MF MG MH MK ML MM MN MO MP MQ MR MS MT MU MV MW MX MY MZ NA NC NE NF NG NI NL NO NP NR NU NZ OM PA PE PF PG PH PK PL PM PN PR PS PT PW PY QA RE RO RS RU RW SA SB SC SD SE SG SH SI SJ SK SL SM SN SO SR SS ST SV SX SY SZ TC TD TF TG TH TJ TK TL TM TN TO TR TT TV TW TZ UA UG UM US UY UZ VA VC VE VG VI VN VU WF WS YE YT ZA ZM ZW US
distance number how far is it from the location described in the request to this pickup location 1.3
distance_units string km
lat string latitude -79.43575121732864
lng string longitude 36.089788917096016
location_code string carrier assigned location ID A4415567
location_name string name of the business/post office United States Postal Service
location_type string the type of this pickup location post_office
postal_code string 27215
state string NC
street1 string 405 Maple Ave


Error Response
Field Possible Values Example
error object
code string Standardized error code required schema_validation_error missing_api_key shipping_account_not_found schema_field_required wrong_api_key carrier_http_exception carrier_timeout carrier_exception unexpected_exception carrier_throttling carrier_unsupported_method shipping_account_wrong_carrier carrier_failed_connection carrier_authentication carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message string Error message required FedEx API: Postal code specified is not in the correct format
Example Request / Response
{
    "dopu": {
        "carrier": "fedex",
        "location": {
            "city": "San Diego",
            "country": "US",
            "postal_code": "92131",
            "state": "CA",
            "street1": "1 Market Street"
        },
        "shipping_account": "673603996",
        "test": true
    }
}
                curl --request POST \
--url https://api.zenkraft.com/dopu \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "dopu": {
        "carrier": "fedex",
        "location": {
            "city": "San Diego",
            "country": "US",
            "postal_code": "92131",
            "state": "CA",
            "street1": "1 Market Street"
        },
        "shipping_account": "673603996",
        "test": true
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "dopu": {
        "carrier": "fedex",
        "location": {
            "city": "San Diego",
            "country": "US",
            "postal_code": "92131",
            "state": "CA",
            "street1": "1 Market Street"
        },
        "shipping_account": "673603996",
        "test": true
    }
}
url = "https://api.zenkraft.com/dopu"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "locations": [
    {
      "location_type": "post_office",
      "distance": 1.3,
      "distance_units": "km",
      "location_name": "United States Postal Service",
      "location_code": "A4415567",
      "city": "Burlington",
      "street1": "405 Maple Ave",
      "state": "NC",
      "postal_code": "27215",
      "country": "US",
      "lng": "36.089788917096016",
      "lat": "-79.43575121732864"
    }
  ]
}

/manifest POST

Manifesting allows you to notify the carrier that your shipments are ready for shipping/pickup.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
manifest object required
debug boolean calls with debug=true will be logged
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers


Successful Response
Field Possible Values Example
manifest object
costs object Additional information about packages
base_charge number gross amount 100
discounts number the cost of discounts applied
net_charge number net amount 80
surcharges number additional fees
taxes number the cost of taxes 20
id string carrier ID of this manifest which can be used in GET on /manifest/<manifest_id> 963681622636173689
shipping_documents object Additional information about packages
description string description of this customs item required Manifest
document string base64 document contents required
document_type string file format of the document required PDF


Error Response
Field Possible Values Example
error object
code string Standardized error code. If the code equals `carrier_large_manifest` you might retrieve manifest_id from the error detail required schema_validation_error missing_api_key shipping_account_not_found schema_field_required wrong_api_key carrier_http_exception carrier_timeout carrier_large_manifest carrier_exception unexpected_exception carrier_throttling carrier_unsupported_method shipping_account_wrong_carrier carrier_failed_connection carrier_authentication carrier_large_manifest
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required 963681622636173689
message string Error message required The manifest is too large and it's going to take around 15 to generate. Retry again later please
Example Request / Response
{
    "manifest": {
        "carrier": "fedex",
        "debug": true,
        "shipping_account": 40910738,
        "test": true,
        "tracking_numbers": [
            "33GKB500127801000961509",
            "111JD575508301000961502",
            "111JD575511501000961500"
        ]
    }
}
                curl --request POST \
--url https://api.zenkraft.com/manifest \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "manifest": {
        "carrier": "fedex",
        "debug": true,
        "shipping_account": 40910738,
        "test": true,
        "tracking_numbers": [
            "33GKB500127801000961509",
            "111JD575508301000961502",
            "111JD575511501000961500"
        ]
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "manifest": {
        "carrier": "fedex",
        "debug": true,
        "shipping_account": 40910738,
        "test": true,
        "tracking_numbers": [
            "33GKB500127801000961509",
            "111JD575508301000961502",
            "111JD575511501000961500"
        ]
    }
}
url = "https://api.zenkraft.com/manifest"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "manifest": {
    "id": "963681622636173689",
    "shipping_documents": [{
      "description": "Manifest",
      "document_type": "PDF",
      "document": "string"
    }],
    "costs": {
      "base_charge": 100,
      "net_charge": 80,
      "taxes": 20,
      "surcharges": 0,
      "discounts": 0
    }
  }
}

/manifest GET

This endpoint allows you to retrieve previously created manifests.

Successful Response
Field Possible Values Example
manifests array
carrier string the carrier name fedex
created string when was this object created 2021-06-02T07:22:43.000
id string carrier ID of this manifest which can be used in GET on /manifest/<manifest_id> 963681622636173689
shipping_account string Shipping account number 5190163571408896


Error Response
Field Possible Values Example
error object
code string Standardized error code required missing_api_key wrong_api_key shipping_account_not_found shipping_account_wrong_carrier schema_validation_error schema_field_required unexpected_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message string Error message required Missing zkkey HTTP header containing your Zenkraft API key
Example Request / Response
https://api.zenkraft.com/manifest
                curl --request GET \
--url https://api.zenkraft.com/manifest \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = None
url = "https://api.zenkraft.com/manifest"

response = requests.request(url=url, method='GET', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "manifests": [
    {
      "carrier": "fedex",
      "created": "2021-06-02T07:22:43.000",
      "id": "963681622636173689",
      "shipping_account": "5190163571408896"
    }
  ]
}

/webhook POST

Webhooks provide you with a real-time view of your shipments.

1. Create a webhook configuration

In order to start using webhooks, you need to create a webhook configuration. You can find an example payload on the right side.

2. Receive a webhook

Now we will start sending tracking event updates as POST requests to your chosen address. The request will be formatted the same way as our track response

3. Verify a webhook

Webhooks can be verified by calculating a digital signature. Each webhook request includes a base64-encoded X-Zenkraft-Hmac-SHA256 header, which is generated using your API key along with the data sent in the request. Once you verify this signature, you can be sure the request came from us and you can continue your processing.

4. Response to a webhook

Your endpoint acknowledges that it received data by sending a 200 response. Any response outside of 200-range is considered an error. On our side, we have set a 5 second timeout. Any errors will be retried in a staggered manner over the course of the day.

Testing a Webhook

To test a webhook, run a local server or use a publicly available service such as Beeceptor. If you decide to run a server locally, then you need to make it publicly available using a service such as Pagekite or ngrok. The following URLs can't be endpoints for a webhook:

  • Localhost
  • Any URL ending in the word "internal"
  • Domains like www.example.com
  • Zenkraft domains such as api.zenkraft.com

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
webhook object required
api_version string The webhook version. Used for future compatibility v1
callback string URL of the receiving endpoint required https://webhook.site/3a788dd3-bd7c-44a8-bae0-297e3b68b508
debug boolean calls with debug=true will be logged
description string Webhook description
events array Events to receive. If left empty, it's assumed you want to receive all the events return.exception return.out_for_delivery shipment.exception return.checked_in return.driver_assigned return.delivered shipment.checked_in shipment.created shipment.creation_pending shipment.out_for_delivery return.creation_pending shipment.driver_assigned shipment.delivered return.picked_up shipment.in_transit return.shipment_voided return.in_transit return.created shipment.shipment_voided shipment.picked_up shipment.delivered
format string Currently only JSON is supported. Used for future compatibility json
headers array Headers that will be sent to the webhook callback.
name string Authorization
value string api_key
name string Webhook name
shipping_account_id integer 123
trigger_mode string stage checkpoint


Successful Response
Field Possible Values Example
webhook object
api_version string The webhook version. Used for future compatibility v1
callback string URL of the receiving endpoint required https://webhook.site/3a788dd3-bd7c-44a8-bae0-297e3b68b508
debug boolean calls with debug=true will be logged
description string Webhook description
[...]
